#!/usr/bin/perl

do "$ENV{'LENSTOOL_DIR'}/perl/rescaleBayes.pl";
$\="\n";
		
$file = "bayes.dat";
$scale = 1;
while( @ARGV > 0 )
{
        if( $ARGV[0] =~ /scale/ )
        {
                @fld = split /=/,$ARGV[0];
                $scale = $fld[1];
        } else
        {
                $file = $ARGV[0];
        }
        shift @ARGV;
}

if( $scale != 1. )
{
	rescaleBayes($file, $scale);
	$file = "bayes_rescaled.dat";
}

system("rm -f a") == 0 or exit;
system("bayesResults.pl $file > a") == 0 or exit;

open(in, 'a');
@lines=<in>;
close(in);
shift @lines;
shift @lines;

# Read the prior.dat if file exists
open(P, 'prior.dat');
@prior = <P>;
close(P);

$i=0;
$rep="";
while( $rep ne "q" )
{
	chop $lines[$i];
	@fld=split /\(|\)/, $lines[$i];

	# Remove the leading color codes in the name
	$fld[0]=substr($fld[0],index($fld[0],"#"));

	open(out,'>plot.inp');
	printf out "$file\n";	#file
	printf out "%d\n", $i+2;	#line index
	if( $#fld > 5 )
	{	# parameter with unit
		printf out "%s)\n", join("(", @fld[0..$#fld-5]);	#name
	}
	else
	{	# parameter without unit
		printf out "%s\n", join("(", @fld[0..$#fld-4]);        #name
	}
	printf out "n\n";		#change range
	printf out "%d\n", $fld[$#fld-3];	#nbin
	printf out "n\n";		#rebin
	if( @prior )
	{
		printf out "y\n";		#overlay std dist
		@fldp =  split ' ', $prior[$i];
		printf out " $fldp[1]\n";
		printf out " $fldp[2] $fldp[3]\n";
		printf out "n\n";		# Try again?
	} else
	{
		printf out "n\n";		#overlay std dist
	}
	printf out "y\n";		#plot PS
	printf out "n\n"; 		#plot points
	printf out "n\n"; 		#plot ref points
	printf out "n\n"; 		#smooth
	close(out);
	system('Histogram < plot.inp > /dev/null');
	chop $fld[0];
	$fld[0] =~ s/#//;
	$fld[0] =~ s/ ://;
	$fld[0] =~ s/ /_/g;
	system("mv pgplot.ps $fld[0].ps");
	read STDIN, $rep, 1;
	if( $rep eq "\n" ) 
	{
		if( $i < $#lines )
		{
			$i++;
		} else
		{
			$rep="q";
		}
	}
	if( $rep eq "b" )
	{
		read STDIN, $rep, 1;	# To empty the STDIN queue
		if( $i > 0 )
		{
			$i--;
		}
	}
	if( $rep eq "?" )
	{
		read STDIN, $rep, 1;    # To empty the STDIN queue
		print "pdfcheck.pl help\n";
		print "----------------\n";
		print "[ENTER] : go forward\n";
		print "b : go backward\n";
		print "q : quit\n";
	}
}

system("rm -f a plot.inp");
