#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		programme 	d_profil.c			*/
/*		auteur		Henri Bonnet			*/
/*		place		OMP				*/
/*		date		12.11.1991			*/
/*		version		1				*/
/****************************************************************
 *	d_profil(x,y,k)
 *		double x,y,k;
 *
 * 	evalue, en (x,y), la fonction:
 *     	f(x,y)=Io/(1+alpha**2*(e**2*(x-C.x)**2+(y-C.y)**2))
 *	k est l'indice de l'objet qu'on integre
 *
 * 	les parametres sont definis dans "para"
 *		alpha=1/(e*l)
 */

double d_profil(double x,double y,struct galaxie *gal)
{
	double xx,yy,xxx,yyy;
	double res;
	extern  struct g_observ O;
	extern  struct g_large L;
	
	res = 0;
	
	if(gal->c=='s')
	{
		xx=x-gal->C.x;
		yy=y-gal->C.y;
		xxx=xx*xx+yy*yy;
		res=100*exp((-1.)*xxx/O.r0st);
	}
	else if (L.vitesse==0)
	{
		xx=((x-gal->C.x)*sin(gal->E.theta)-(y-gal->C.y)*cos(gal->E.theta))/gal->E.b;
		yy=((y-gal->C.y)*sin(gal->E.theta)+(x-gal->C.x)*cos(gal->E.theta))/gal->E.a;
		xxx=xx*xx;
		yyy=yy*yy;
		if (gal->mag>0)
			res=pow(10.,(26.-gal->mag)/2.5)/(1.+(xxx+yyy));
		else
			res=gal->I0/(1.+(xxx+yyy));
	}
	else if (L.vitesse==1)
	{
		xx=((x-gal->C.x)*sin(gal->E.theta)-(y-gal->C.y)*cos(gal->E.theta))/gal->E.b;
		yy=((y-gal->C.y)*sin(gal->E.theta)+(x-gal->C.x)*cos(gal->E.theta))/gal->E.a;
		if (xx*xx+yy*yy<3.)
		{
			res=gal->I0*sqrt(fabs(yy));
			if (yy<0.)
				res=-res;
		}
	}
	return(res);

}
