#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		diag				*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/****************************************************************
 * Same as formeli() but return the inverse of a and b, the proper
 * magnification axis. 
 * 
 * Used in e_test()/e_mag() to define the arclet size in the image plane 
 * from the source size in the source plane.
 */
struct	ellipse	diag(double a,double b,double c)
{
	struct	ellipse	diago;
	double	e,delta,lambda,mu;

	delta=(a-c)*(a-c)+4*b*b;
	e=sqrt(delta);	/*e is the shear*/
	lambda=.5*(a+c+e);
	mu=.5*(a+c-e);

	diago.a=1/lambda;
	diago.b=1/mu;
	if ( lambda != mu && b != 0.)
		diago.theta=atan2(lambda-a,b);
	else
		diago.theta=0.;

	return (diago);
}
