#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

static void rotelip(struct ellipse *el,double theta,struct ellipse *el_r);
static void formatrix(struct ellipse *eli, struct matrix *r);
static void mag(struct matrix *A,struct ellipse *ampli, struct matrix *B);


/****************************************************************/
/*		nom:		isoima				*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/****************************************************************
 * Convert an ellipse from source plane to image plane or from
 * image plane to source plane according to the amplification
 * matrix.
 * 
 * Global variables used : 
 * - none
 */
void isoima(struct ellipse *es,struct ellipse *ampli, struct ellipse *ei)
{
	struct	ellipse	esm,eim;
	struct	matrix	S,I;
	
	/* on se place dans le repere de magnification*/
	
	rotelip(es,ampli->theta,&esm);
	
	/* la matrice des fij, c'est le carre des longueur !!! */
	
	esm.a=esm.a*esm.a;
	esm.b=esm.b*esm.b;
	
	/* on determine la matrice correspondante */
	
	formatrix(&esm, &S);
	
	/* on determine la matrice image */
	
	mag(&S,ampli,&I);
	
	/* on determine l'ellipsoide correspondant */
	
	eim=formeli(I.a,I.b,I.c);
		
	/* l'ellipse c'est la racine carre de l'ellipsoide */
	
	eim.a=sqrt(eim.a);
	eim.b=sqrt(eim.b);
	
	/* on retourne  dans le repere propre*/
	
	rotelip(&eim,-ampli->theta, ei);
}

static void rotelip(struct ellipse *el,double theta, struct ellipse *el_r)
{
	el_r->a=el->a;
	el_r->b=el->b;
	el_r->theta=el->theta-theta;
}

static void formatrix(struct ellipse *eli, struct matrix *r)
{
	struct matrix m;
	m.a=eli->a;
	m.c=eli->b;
	m.b=m.d=0.;
	*r=rotmatrix(&m,eli->theta);
}

static void mag(struct matrix *A,struct ellipse *ampli, struct matrix *B)
{
	double alpha, beta;
	alpha = ampli->a;
	beta = ampli->b;
	
	B->a=alpha*alpha*A->a;
	B->b=B->d=alpha*beta*A->b;
	B->c=beta*beta*A->c;
}
