#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>


/*
* local	
* Jean-Paul Kneib
* jan 95	
* Cambridge
*/

void	local(int type,char localfile[])
{
	extern	struct	g_source	S;
	extern	struct	pot	lens[];
	
	FILE	*OUT;
	struct	galaxie	alet[NAMAX];
	int	na;
	
	struct  ellipse ampli;
	struct  matrix  M;
	double	q,eps,tau,epsx,epsy,taux,tauy,ka,ga1,ga2,ga;
	double	dlsds;
	
	register int	i;
	
	
	na=0;
	if (type>0)
		f_shape(&na,alet,localfile);
	else
		f_shape2(&na,alet,localfile);
	
	
	OUT=fopen("local.dat","w");
	
	for(i=0;i<na;i++)
	{
		if (alet[i].z<=lens[0].z)
			dlsds=dratio(lens[0].z,S.zs);
		else
			dlsds=dratio(lens[0].z,alet[i].z);
	
		ampli=e_unmag_gal(&alet[i],dlsds);
		q=alet[i].E.b/alet[i].E.a;
		eps=(1.-q*q)/(1.+q*q);
		tau=.5*(1./q-q);
		epsx=-eps*cos(2.*(alet[i].E.theta-ampli.theta));
		epsy=eps*sin(2.*(alet[i].E.theta-ampli.theta));
		taux=-tau*cos(2.*(alet[i].E.theta-ampli.theta));
		tauy=tau*sin(2.*(alet[i].E.theta-ampli.theta));
	
		M=e_grad2_gal(&alet[i]);
		M.a*=dlsds;
		M.b*=dlsds;
		M.c*=dlsds;
		M.d*=dlsds;
		ka=(M.a+M.c)/2.;
		ga1=(M.a-M.c)/2.;
		ga2=M.b;
		ga=sqrt(ga1*ga1+ga2*ga2);
	
		fprintf(OUT,
			"%s %.3lf %.3lf   %.3lf %.3lf %.3lf    %.3lf %.3lf %.3lf    %.3lf %.3lf %.3lf\n",
			alet[i].n,alet[i].C.x,alet[i].C.y,
			eps,epsx,epsy,tau,taux,tauy,ka,ga1,ga2
			);
	}
	
	fclose(OUT);
}
