#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/********************************************************/
/*		fonction: o_chi 			*/
/*		auteur: jpk				*/
/********************************************************/

double	o_chi_pos()
{
	/* variables externes */
	
	extern	double	chip,chia,chix,chiy,chil,chis,chi_im;
	extern	struct  g_mode  M;
	//extern	struct	g_source	S;
	//extern	struct	g_grille	G;
	extern	struct	g_image		I;
	extern	struct	g_cosmo		C;
	//extern	struct	pot	lens[];
	//extern	struct	ipot	ip;
	extern	struct	galaxie		arclet[NAMAX];
	extern	struct	galaxie		multi[][NIMAX];
	extern	struct	cline		cl[];
	extern	int	narclet; //,block[][NPAMAX];
	
	extern	double	elix;
	extern	struct	point	SC;
	
	//extern  double	**map_p,**map_axx,**map_ayy;
	
	/* local variables */
	
	register int 	i,j;
	double	x,y,chi=0.;
	double	dy;
	double	dx,da; //sigx2,sigy2,siga2;
	double	qp,dp,tp;
	double	ampa,ampb,d;
	struct	point	A,B,D;
	struct	point	Ps[NIMAX],multib[NIMAX];
	struct	point	Bs;
	
	/* variables locales images */
	
	struct  ellipse ell_sou,source,ampli;
	
	//extern	int	nplo,**imuo;
	//extern	double	drima,**imo,**ero,**soo;
	//extern	struct	pixlist	plo[];
	
	
	chis=0.;
	if(I.stat!=0)
	{
		if ((I.stat==1)||(I.stat==2))
		{
			for (i=0;i<narclet;i++)
			{
				/* optimisation du z */
				if (I.stat==2)
				{
					if(indexCmp(I.nza,arclet[i+1].n)) //I.nza!=i+1
					{
						SC=arclet[i].C;
						ampli=e_unmag(&SC,arclet[i].dr);
						elix=fabs(arclet[i].eps*cos(2*(arclet[i].E.theta-ampli.theta)));
						arclet[i].dr=zero_t(arclet[i].dr,arclet[i].dr+.05,fmin_ell);
					}
					else
						arclet[i].dr=I.drarclet;
				}
		
				/* calcul de ts optimise */
		
	            ampli=e_unmag_gal(&arclet[i],arclet[i].dr);
	            isoima(&arclet[i].E,&ampli,&ell_sou);
	            x=ell_sou.b/ell_sou.a;
	            x=.5*(1./x-x);
			
				if (I.stat==2)
				{
					if(indexCmp(I.nza,arclet[i+1].n)) //I.nza!=i+1
						chis+=x*x;
					else
						chis+=50.*x*x;
				}
				else
					chis+=x*x;
			}
		}
		else if (I.stat==3)	/* optimisation de l'orientation */
		{
			for (i=0;i<narclet;i++)
			{
		        ampli=e_unmag_gal(&arclet[i],arclet[i].dr);
				x=arclet[i].tau*sin( 2.*(arclet[i].E.theta-ampli.theta));
				chis+=x*x;
			}
		}
		else if (I.stat==4)	/* optimisation orientation + ellipticite*/
		{
			for (i=0;i<narclet;i++)
			{
				ampli=e_unmag_gal(&arclet[i],arclet[i].dr);
				qp=fabs(ampli.b/ampli.a);
				dp=(1.+qp*qp)/2./qp;
				tp=fabs(1.-qp*qp)/2./qp;
				x=dp*arclet[i].tau*cos( 2.*(arclet[i].E.theta-ampli.theta))
					-tp*arclet[i].dis;
				chis+=x*x;
			}
			chis /=narclet;
		}
		else if (I.stat==5)	/* optimisation orientation + ellipticite*/
		{
			for (i=0;i<narclet;i++)
			{
					ampli=e_unmag_gal(&arclet[i],arclet[i].dr);
					isoima(&arclet[i].E,&ampli,&source);
					x=fabs( (source.a*source.a-source.b*source.b)
						/2./source.a*source.b);
					chis+=x*x/0.001;
			}
			chis /=narclet;
		}
		else
		{
			NPRINTF(stderr,"ERROR in o_chi/arclet\n");
			exit(-1);
		}		
	}
	
	
	if (I.n_mult!=0)
	{
		chip=0.;
		chia=0.;
		for(i=0;i<I.n_mult;i++)
		{
			if(I.sigposAs!=0.)
			{
				y=I.sigposAs*d0/C.h*distcosmo1(multi[i][0].z);
				I.sig2pos=y*y;
			};
	
			o_dpl(I.mult[i],multi[i],Ps);
			Bs=bcentlist(Ps,I.mult[i]);
			unlens_bc(Ps,Bs,multi[i],multib,I.mult[i]);
	
	
	        for (j=0;j<I.mult[i];j++)
	        {
	            dx=multi[i][j].C.x-multib[j].x;
	            dy=multi[i][j].C.y-multib[j].y;
	            chip += dx*dx/I.sig2pos+dy*dy/I.sig2pos;
				NPRINTF(stderr,"(%.2lf,%.2lf) (%.2lf,%.2lf)\n",
				   multi[i][j].C.x,multi[i][j].C.y,multib[j].x,multib[j].y);
	        }
			for (j=0;j<I.mult[i];j++)
	        {
		        da=diff_mag(multi[i][j],multib[j]);
		        chia += da*da/I.sig2amp;
	        }
			NPRINTF(stderr,"%.2lf %.2lf\n", chip,chia);
		}
	}
	
	if (I.npcl!=0)
	{
		chil=0.;
		for(i=0;i<I.npcl;i++)
		{
			A.x=cl[i].C.x-cl[i].dl*cos(cl[i].phi);
			A.y=cl[i].C.y-cl[i].dl*sin(cl[i].phi);
			B.x=cl[i].C.x+cl[i].dl*cos(cl[i].phi);
			B.y=cl[i].C.y+cl[i].dl*sin(cl[i].phi);
			ampa=e_amp(&A,cl[i].dlsds);
			ampb=e_amp(&B,cl[i].dlsds);
			if (ampa*ampb<0.)
				D=e_zeroamp(A,B,cl[i].dlsds);
			else
			{
				if ((B.x!=A.x)&&(ampb!=ampa))
					D.x=(ampb*A.x-ampa*B.x)/(ampb-ampa);
				else
					D.x=A.x;
				if ((B.y!=A.y)&&(ampb!=ampa))
					D.y=(ampb*A.y-ampa*B.y)/(ampb-ampa);
				else
					D.y=A.y;
			}
			d=dist(D,cl[i].C)/cl[i].dl;
			chil+=d*d;
		}
	}
	
	chi=chi_im+chis+chil+Min(chip+chix+chiy+chia,100000.);
	NPRINTF(stderr,"\n %lf %lf %lf\n",chi,chip,chia);
	
	return(chi);
}
