#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*                 Program  : grille				*/
/*                 Version  : 1 mai 1992			*/
/*                 Location : Obs. Toulouse			*/
/*                 Auteur   : jean-paul				*/
/****************************************************************/

void r_potfile(FILE *IN,FILE *OUT,int *ilens)
{
	extern struct	g_pot	P;
	extern  struct  g_mode          M;
	int	nplens;
	char	second[20],third[120];
	
	strcpy(P.potfile, "");

	fmot(IN,second);
	while(strcmp(second,"end"))
	{
		flire(IN,third);
		
		if (!strcmp(second,"filein"))
		{
			sscanf(third,"%d%s",&P.ftype,P.potfile);
			fprintf(OUT,"\t%s\t%d %s\n",second,P.ftype,P.potfile);
		}
		else if (!strcmp(second,"type"))
		{
	            sscanf(third,"%d",&P.type); 
	            fprintf(OUT,"\t%s\t%d\n",second,P.type);
		}
		else if (!strcmp(second,"zlens") || !strcmp(second,"z_lens") )
		{
	            sscanf(third,"%lf",&P.zlens); 
	            fprintf(OUT,"\t%s\t%lf\n",second,P.zlens);
		}
		else if (!strcmp(second,"mag0"))
		{
	            sscanf(third,"%lf",&P.mag0); 
	            fprintf(OUT,"\t%s\t%lf\n",second,P.mag0);
		}
		else if (!strcmp(second,"core"))
		{
	            sscanf(third,"%lf",&P.core); 
	            fprintf(OUT,"\t%s\t%lf\n",second,P.core);
		}
		else if (!strcmp(second,"corekpc"))
		{
	            sscanf(third,"%lf",&P.corekpc); 
	            fprintf(OUT,"\t%s\t%lf\n",second,P.corekpc);
		}
		else if (!strcmp(second,"cut"))
		{
	            sscanf(third,"%d%lf%lf",&P.ircut,&P.cut1,&P.cut2); 
	            fprintf(OUT,"\t%s\t%d %lf %lf\n",second,P.ircut,P.cut1,P.cut2);
		}
		else if (!strcmp(second,"cutkpc"))
		{
	            sscanf(third,"%d%lf%lf",&P.ircut,&P.cutkpc1,&P.cutkpc2); 
	            fprintf(OUT,"\t%s\t%d %lf %lf\n",second,P.ircut,P.cutkpc1,P.cutkpc2);
        	}
		else if (!strcmp(second,"slope"))
		{
			sscanf(third,"%d%lf%lf",&P.islope,&P.slope1,&P.slope2);
			fprintf(OUT,"\t%s\t%d %lf %lf\n",second,P.islope,P.slope1,P.slope2);
		}
		else if (!strcmp(second,"sigma"))
		{
			sscanf(third,"%d%lf%lf",&P.isigma,&P.sigma1,&P.sigma2);
			fprintf(OUT,"\t%s\t%d %lf %lf\n",second,P.isigma,P.sigma1,P.sigma2);
		}
		else if (!strcmp(second,"vdslope"))
		{
            	sscanf(third,"%d%lf%lf",&P.ivdslope,&P.vdslope1,&P.vdslope2);
	            fprintf(OUT,"\t%s\t%d %lf %lf\n",second,P.ivdslope,
				P.vdslope1,P.vdslope2);
		}

		// Read the next line
		fmot(IN,second);
	}
	
	fprintf(OUT,"\t%s\n",second);

	// In the case, potfile is just used to define mag0
	if( !strcmp(P.potfile,"") )
		return;

	if (P.zlens<=0.)
	{
		NPRINTF(stderr,"ERROR: z_lens keyword not defined in the potfile section\n");
		exit(-1);
	}
		
	nplens = *ilens;

	/* initialize the potential from file */	
	*ilens += set_potfile(nplens);
}
