#include<stdio.h>
#include<string.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>


/****************************************************************/
/*		nom:		set_default			*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/03/94			*/
/*		place:		ESO LaSilla			*/
/****************************************************************/

void	set_default()
{
	extern struct g_mode    M;
	extern struct g_source  S;
	extern struct g_image   I;
	extern struct g_grille  G;
	extern struct g_frame   F;
	extern struct g_large   L;
	extern struct g_cosmo   C;
	extern struct g_cline   CL;
	extern struct g_observ  O;/* default flux dispersion^2 */
	extern struct g_pot     P;
	extern struct ipot      ip;	
	
	/* runmode */
	
	M.verbose=0;
	M.seeing=0.;
	M.sort=0;
	M.minchi0=0.1;
	
	/* image */
	
	I.forme=1;
	I.mult_abs=0;
	I.Anfilt=15;
	I.Anpixseeing=6;
	I.sigell=0.3;
	I.dsigell=-1.;
	I.sigposAs=0.2;	/* default position dispersion */
	I.dsigposAs=-1.;  // not optimized
	I.sig2amp=0.04;	/* default flux dispersion^2 */
	I.Dmag=0.1;
	
	/* crtitical line */
	
	CL.nplan=0;
	CL.zone=0;
	CL.npzone=100;
	strcpy(CL.zonefile,"zone.dat");
	CL.limitHigh=10;	// (arcsec) limitHigh for marchingSquares
	CL.cpas=1;			// (arcsec) limitLow for marchingSquares
	CL.dmax=0.;			// field is computed from the champ section
	strcpy(CL.algorithm, "MARCHINGSQUARES" );
	
	/* large */
	
	strcpy(L.iname,"giant");
	L.dlarge=2.;
	L.vitesse=0;
	L.iso=0;
	L.nmaxiso=0;
	L.scale=1;
	L.zonex=0;
	L.zoney=0;
	L.profil=0;
	L.pt=0;
	L.ncourbe=0;
	L.npt=0;
	 
	
	/* grille */
	
	G.pol=0;
	G.no_lens=0;
	G.nlens=0;
	G.ngrid=30;
	G.nlens_crit=0;
	
	/* source */
	
	S.zs=0.8;
	S.ns=0;
	S.grid=0;
	S.rand=-2;
	S.distz=0;
	S.emax=0.3;
	S.zsmin=0.5;
	S.zsmax=1.5;
	S.taille=0.3;
	S.lfalpha=-1;
	S.lfm_star=-20;
	S.lfm_min=-24;
	S.lfm_max=-16;
	
	/* frame */
	
	F.xmin=-20.;
	F.xmax=20.;
	F.ymin=-20.;
	F.ymax=20.;
	F.rmax=25.;
	
	/* potfile */
	
	P.mag0=17.;
	P.isigma=0;
	P.ircut=0;
	P.islope=0;
	P.ivdslope=0;
	P.type=81;
	P.corekpc = P.core = -1.0; 
	P.cutkpc1 = P.cut1 = P.cut = -1.0;
	P.sigma1 = P.sigma = -1.0;
	P.slope1=4.; 
	P.vdslope1=4.;

	/* cosmology */
	
	C.H0=50.;
	C.h=1.;
	C.omegaM=1.;
	C.omegaX=0.;
	C.kcourb=0.;
	C.wX=-1.;
	
	/* observe */
	
	O.prec=0.2;
	O.bruit=0;
	O.idum=-1;
	O.setseeing=0;
	O.setbin=0;
	O.bin=0;
	O.setseeing=0;
	O.filtre=0;
	O.seeing=1.;
	O.r0st=0;
	O.SKY=100;
	O.gain=1.;

	// Parameters
	ip.pmax=11;
      ip.extend=1;
      ip.map=0;
}

