#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		sig2posS4je			*/
/*		auteur:		Eric Jullo			*/
/*		date:		01/07   			*/
/*		place:		Marseille			*/
/****************************************************************
 * Compute sig2pos in the source plane using the major and minor axis
 * size as 1sigma error in the image plane.
 * 
 * Global variables used :
 * 
 */
void sig2posSe(struct galaxie *multi,int n, double *sigx2, double *sigy2)
{
	
	struct  ellipse ampli,source;
//	double  costh, sinth, sigx, sigy;
	int  j;
	
	*sigx2 = 0;
	for( j = 0; j < n; j++ )
	{
		// return the amplication matrix (same det as in amplif.c with e_amp() )
		ampli = e_unmag(&multi[j].C,multi[j].dr);
		isoima(&multi[j].E,&ampli,&source);
	
/*		costh=cos(source.theta);
		sinth=sin(source.theta);
		if( source.a*costh > source.b*sinth) sigx = source.a*costh; else sigx = source.b*sinth;
		if( source.a*sinth > source.b*costh) sigy = source.a*sinth; else sigy = source.b*costh;
		*sigx2 += sigx*sigx;
		*sigy2 += sigy*sigy;
		*sigx2 += source.a * source.a;
		*sigy2 += source.b * source.b;
*/
		*sigx2 += source.a * source.b;
	}
	*sigx2 /= n;
	*sigy2 = *sigx2;
}

